
#include <stdio.h>
#include <math.h>

#include "kaapi_impl.h"

#define KAAPI_PERFMODEL_FILE    "kaapi_perfmodel_dump"
#define KAAPI_PERFMODEL_MAX_PARAMS    8

static kaapi_atomic_t perfmodel_init = {0};

void kaapi_perfmodel_init(void)
{
  if (KAAPI_ATOMIC_INCR(&perfmodel_init) != 1)
    return;
  
  const char* calibrate = getenv("KAAPI_PERFMODEL_CALIBRATE");
  if( calibrate != 0 )
  {
    kaapi_default_param.perfmodel_calibrate = atoi(calibrate);
  }
  
  kaapi_perfmodel_task_init();
  kaapi_perfmodel_comm_init();
}

void kaapi_perfmodel_finalize(void)
{
  if (KAAPI_ATOMIC_DECR(&perfmodel_init) != 0)
    return;
  
  kaapi_perfmodel_task_finalize();
  kaapi_perfmodel_comm_finalize();
  
  kaapi_default_param.perfmodel_calibrate = 0;
}
