
#ifndef _KAAPI_PERFMODEL_COMM_HISTORY_H_
#define _KAAPI_PERFMODEL_COMM_HISTORY_H_

#include "kaapi_impl.h"

#if defined(KAAPI_USE_CUDA)

extern void kaapi_perfmodel_comm_history_init(void);

extern void kaapi_perfmodel_comm_history_finalize(void);

extern double kaapi_perfmodel_comm_history_predict(kaapi_processor_t* const kproc, kaapi_taskdescr_t* const td);

extern void kaapi_perfmodel_comm_history_update_entry(const kaapi_address_space_id_t src_asid, const kaapi_address_space_id_t dst_asid,
                                               const size_t size, const double time);

#else /* KAAPI_USE_CUDA */

static inline void kaapi_perfmodel_comm_history_init(void) {}

static inline void kaapi_perfmodel_comm_history_finalize(void) {}

static inline double kaapi_perfmodel_comm_history_predict(kaapi_processor_t* const kproc, kaapi_taskdescr_t* const td)
{
  return 0.f;
}

static inline void kaapi_perfmodel_comm_history_update_entry(const kaapi_address_space_id_t src_asid, const kaapi_address_space_id_t dst_asid, const size_t size, const double time)
{
}

#endif /* KAAPI_USE_CUDA */

#endif /* _KAAPI_PERFMODEL_COMM_HISTORY_H_ */
