/*
** kaapi_fmt_predef.c
** xkaapi
** 
**
** Copyright 2009,2010,2011,2012 INRIA.
**
** Contributors :
**
** thierry.gautier@inrialpes.fr
** 
** This software is a computer program whose purpose is to execute
** multithreaded computation with data flow synchronization between
** threads.
** 
** This software is governed by the CeCILL-C license under French law
** and abiding by the rules of distribution of free software.  You can
** use, modify and/ or redistribute the software under the terms of
** the CeCILL-C license as circulated by CEA, CNRS and INRIA at the
** following URL "http://www.cecill.info".
** 
** As a counterpart to the access to the source code and rights to
** copy, modify and redistribute granted by the license, users are
** provided only with a limited warranty and the software's author,
** the holder of the economic rights, and the successive licensors
** have only limited liability.
** 
** In this respect, the user's attention is drawn to the risks
** associated with loading, using, modifying and/or developing or
** reproducing the software by the user in light of its specific
** status of free software, that may mean that it is complicated to
** manipulate, and that also therefore means that it is reserved for
** developers and experienced professionals having in-depth computer
** knowledge. Users are therefore encouraged to load and test the
** software's suitability as regards their requirements in conditions
** enabling the security of their systems and/or data to be ensured
** and, more generally, to use and operate it in the same conditions
** as regards security.
** 
** The fact that you are presently reading this means that you have
** had knowledge of the CeCILL-C license and that you accept its
** terms.
** 
*/
#include "kaapi_format.h"
#include "kaapi_hashmap.h"
#include <string.h>

kaapi_atomic_t kaapi_count_format_byfmtid = {0};

kaapi_format_t* kaapi_all_format_byfmtid[KAAPI_FORMAT_MAX] = 
{
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};


/**
*/
kaapi_format_id_t kaapi_format_register( 
        kaapi_format_t*           fmt,
        const char*               name
)
{
  uint8_t        entry;
  kaapi_format_t* head;

  memset( fmt, 0, sizeof(kaapi_format_t) );
  fmt->fmtid  = kaapi_hash_value( name );
  fmt->name   = strdup(name);
  fmt->isinit = 1;

  fmt->name_dot  = 0;
  fmt->color_dot = 0;

  /* register it into hashmap: fmtid -> fmt */
  entry = (uint8_t) (fmt->fmtid & (kaapi_format_id_t)0xFFUL);
  head =  kaapi_all_format_byfmtid[entry];
  fmt->next_byfmtid = head;
  kaapi_all_format_byfmtid[entry] = fmt;

  KAAPI_ATOMIC_INCR(&kaapi_count_format_byfmtid);
  return fmt->fmtid;
}

/**
*/
kaapi_format_t* kaapi_format_allocate( )
{
  return malloc( sizeof(kaapi_format_t) );
}
