/*
** xkaapi
** 
**
** Copyright 2009,2010,2011,2012 INRIA.
**
** Contributors :
**
** thierry.gautier@inrialpes.fr
** 
** This software is a computer program whose purpose is to execute
** multithreaded computation with data flow synchronization between
** threads.
** 
** This software is governed by the CeCILL-C license under French law
** and abiding by the rules of distribution of free software.  You can
** use, modify and/ or redistribute the software under the terms of
** the CeCILL-C license as circulated by CEA, CNRS and INRIA at the
** following URL "http://www.cecill.info".
** 
** As a counterpart to the access to the source code and rights to
** copy, modify and redistribute granted by the license, users are
** provided only with a limited warranty and the software's author,
** the holder of the economic rights, and the successive licensors
** have only limited liability.
** 
** In this respect, the user's attention is drawn to the risks
** associated with loading, using, modifying and/or developing or
** reproducing the software by the user in light of its specific
** status of free software, that may mean that it is complicated to
** manipulate, and that also therefore means that it is reserved for
** developers and experienced professionals having in-depth computer
** knowledge. Users are therefore encouraged to load and test the
** software's suitability as regards their requirements in conditions
** enabling the security of their systems and/or data to be ensured
** and, more generally, to use and operate it in the same conditions
** as regards security.
** 
** The fact that you are presently reading this means that you have
** had knowledge of the CeCILL-C license and that you accept its
** terms.
** 
*/
#include "kaapic.h"
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

void whatever_function(int i, int j, int tid, int* result)
{
  for (; i<j; ++i)
    result[i]++;
}

/* main entry point : Kaapi initialization
*/
int main(int argc, char** argv)
{  
  int j,k;
  int result[8192];
  int nthreads;
  kaapic_foreach_attr_t attr;
  kaapi_cpuset_t cpuset;

  /* start all the thread */
  kaapic_init(KAAPIC_START_ONLY_MAIN);

  nthreads = kaapic_get_concurrency();
  kaapi_cpuset_clear(&cpuset);
  for (j=0; j<nthreads; ++j)
   if ( (j %2) == 0)
     kaapi_cpuset_set(&cpuset,j);
  
  kaapic_foreach_attr_init(&attr);
  kaapic_foreach_attr_set_policy(&attr, KAAPIC_FOREACH_SCHED_DISTRIBUTE);
  kaapic_foreach_attr_set_cpuset(&attr, &cpuset);
  
  for (j=0; j<8192; ++j)
    result[j] = 0;

  for (j=0; j<10; ++j)
  {
     kaapic_foreach( 
       0,
       8192,    /* range */
       &attr,   /* attribut */
       1,       /* #function args */
       whatever_function,
       result 
     );

    for (k=0; k<8192; ++k)
      if (result[k]!= j+1)
      {
        printf("Error: [%i]=%i, expected: %i\n", k, result[k], j+1);
        abort();
      }
  }
  
  kaapic_finalize();
  printf("Success\n");  
  return 0;
}

